



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>(java oracle)以bean和array为参数的存储过程及dao部分代码</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">(java oracle)以bean和array为参数的存储过程及dao部分代码</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 09:33:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、数据库部分</h2>
<p>1.创建bean对象</p>
<div>
<pre class="prettyprint linenums"> CREATE OR REPLACE TYPE "QUARTZJOBBEAN" as object<br />
 (<br />
 -- Author  : Duwc<br />
 -- Purpose : for QuartzJobBean<br />
   job_name          varchar2(200),<br />
   job_group         varchar2(200),<br />
   job_class_name    varchar2(250),<br />
   trigger_name      varchar2(200),<br />
   trigger_group     varchar2(200),<br />
   trigger_state     varchar2(16),<br />
   trigger_type      varchar2(8),<br />
   t1                varchar2(200),<br />
   t2                varchar2(200),<br />
   t3                varchar2(200),<br />
   is_durable        varchar2(1),<br />
   is_volatile       varchar2(1),<br />
   is_stateful       varchar2(1),<br />
   requests_recovery varchar2(1),<br />
   priority          number(13),<br />
   start_time        number(13),<br />
   end_time          number(13),<br />
   calendar_name     varchar2(200),<br />
   misfire_instr     number(2)<br />
 )</pre>
</div>
<p>2.创建array对象</p>
<div>
<pre class="prettyprint linenums">CREATE OR REPLACE TYPE "QUARTZJOBARRAY"  is table of QUARTZJOBBEAN</pre>
</div>
<p>3.存储过程PACKAGE部分</p>
<div>
<pre class="prettyprint linenums"> CREATE OR REPLACE PACKAGE PKG_MODULES_DM_QUARTZ AS

   /*插入定时任务表*/<br />
   PROCEDURE INSERT_QUARTZJOB(v_bean QUARTZJOBBEAN);

   /*暂停定时任务表*/<br />
   PROCEDURE PAUSE_QUARTZJOB(v_array QUARTZJOBARRAY);<br />
 END;</pre>
</div>
<p>4.存储过程BODY部分</p>
<div>
<pre class="prettyprint linenums"> CREATE OR REPLACE PACKAGE BODY PKG_MODULES_DM_QUARTZ AS<br />
   /*插入定时任务表*/<br />
   PROCEDURE INSERT_QUARTZJOB(v_bean QUARTZJOBBEAN) IS<br />
   BEGIN<br />
     insert into QRTZ_JOB_DETAILS<br />
       (JOB_NAME,<br />
        JOB_GROUP,<br />
        DESCRIPTION,<br />
        JOB_CLASS_NAME,<br />
        IS_DURABLE,<br />
        IS_VOLATILE,<br />
        IS_STATEFUL,<br />
        REQUESTS_RECOVERY)<br />
     values<br />
       (v_bean.job_name,<br />
        v_bean.job_group,<br />
        v_bean.job_name,<br />
        v_bean.job_class_name,<br />
        v_bean.is_durable,<br />
        v_bean.is_volatile,<br />
        v_bean.is_stateful,<br />
        v_bean.requests_recovery);

     insert into QRTZ_TRIGGERS<br />
       (TRIGGER_NAME,<br />
        TRIGGER_GROUP,<br />
        JOB_NAME,<br />
        JOB_GROUP,<br />
        IS_VOLATILE,<br />
        PRIORITY,<br />
        TRIGGER_STATE,<br />
        TRIGGER_TYPE,<br />
        START_TIME,<br />
        END_TIME,<br />
        CALENDAR_NAME,<br />
        MISFIRE_INSTR)<br />
     values<br />
       (v_bean.trigger_name,<br />
        v_bean.trigger_group,<br />
        v_bean.job_name,<br />
        v_bean.job_group,<br />
        v_bean.is_volatile,<br />
        v_bean.priority,<br />
        v_bean.trigger_state,<br />
        v_bean.trigger_type,<br />
        v_bean.start_time,<br />
        v_bean.end_time,<br />
        v_bean.calendar_name,<br />
        v_bean.misfire_instr);

     if v_bean.trigger_type = 'CRON' then<br />
       insert into QRTZ_CRON_TRIGGERS<br />
         (TRIGGER_NAME, TRIGGER_GROUP, CRON_EXPRESSION, TIME_ZONE_ID)<br />
       values<br />
         (v_bean.trigger_name,<br />
          v_bean.trigger_group,<br />
          v_bean.t1,<br />
          'Asia/Shanghai');<br />
     elsif v_bean.trigger_type = 'SIMPLE' then<br />
       insert into QRTZ_SIMPLE_TRIGGERS<br />
         (TRIGGER_NAME,<br />
          TRIGGER_GROUP,<br />
          REPEAT_COUNT,<br />
          REPEAT_INTERVAL,<br />
          TIMES_TRIGGERED)<br />
       values<br />
         (v_bean.trigger_name,<br />
          v_bean.trigger_group,<br />
          to_number(v_bean.t2),<br />
          to_number(v_bean.t3),<br />
          0);<br />
     end if;<br />
     commit;<br />
   END;

   /*暂停定时任务表*/<br />
   PROCEDURE PAUSE_QUARTZJOB(v_array QUARTZJOBARRAY) IS<br />
     v_bean QUARTZJOBBEAN;<br />
   BEGIN<br />
     for i in v_array.first .. v_array.last loop<br />
       v_bean := v_array(i);<br />
       update QRTZ_TRIGGERS<br />
          set TRIGGER_STATE = 'PAUSED'<br />
        where trigger_name = v_bean.trigger_name<br />
          and trigger_group = v_bean.trigger_group;<br />
       commit;<br />
     end loop;<br />
   END;

 END;</pre>
</div>
<h2>二、dao部分</h2>
<p>1.创建bean对象</p>
<div>
<pre class="prettyprint linenums"> package com.ecnt.gnop.modules.dm.quartz.bean;

 public class QuartzJobBean {

     private String job_name;

     private String job_group;

     private String job_class_name;

     private String trigger_name;

     private String trigger_group;

     private String trigger_state;

     private String trigger_type;

     private String t1;

     private String t2;

     private String t3;

     private String is_durable;

     private String is_volatile;

     private String is_stateful;

     private String requests_recovery;

     private int priority;

     private int start_time;

     private int end_time;

     private String calendar_name;

     private String misfire_instr;

     public Object[] toArray() {<br />
         Object[] obj = new Object[19];<br />
         obj[0] = job_name;<br />
         obj[1] = job_group;<br />
         obj[2] = job_class_name;<br />
         obj[3] = trigger_name;<br />
         obj[4] = trigger_group;<br />
         obj[5] = trigger_state;<br />
         obj[6] = trigger_type;<br />
         obj[7] = t1;<br />
         obj[8] = t2;<br />
         obj[9] = t3;<br />
         obj[10] = is_durable;<br />
         obj[11] = is_volatile;<br />
         obj[12] = is_stateful;<br />
         obj[13] = requests_recovery;<br />
         obj[14] = priority;<br />
         obj[15] = start_time;<br />
         obj[16] = end_time;<br />
         obj[17] = calendar_name;<br />
         obj[18] = misfire_instr;<br />
         return obj;<br />
     }

     public String getCalendar_name() {<br />
         return calendar_name;<br />
     }

     public void setCalendar_name(String calendar_name) {<br />
         this.calendar_name = calendar_name;<br />
     }

     public int getEnd_time() {<br />
         return end_time;<br />
     }

     public void setEnd_time(int end_time) {<br />
         this.end_time = end_time;<br />
     }

     public String getIs_durable() {<br />
         return is_durable;<br />
     }

     public void setIs_durable(String is_durable) {<br />
         this.is_durable = is_durable;<br />
     }

     public String getIs_stateful() {<br />
         return is_stateful;<br />
     }

     public void setIs_stateful(String is_stateful) {<br />
         this.is_stateful = is_stateful;<br />
     }

     public String getIs_volatile() {<br />
         return is_volatile;<br />
     }

     public void setIs_volatile(String is_volatile) {<br />
         this.is_volatile = is_volatile;<br />
     }

     public String getMisfire_instr() {<br />
         return misfire_instr;<br />
     }

     public void setMisfire_instr(String misfire_instr) {<br />
         this.misfire_instr = misfire_instr;<br />
     }

     public int getPriority() {<br />
         return priority;<br />
     }

     public void setPriority(int priority) {<br />
         this.priority = priority;<br />
     }

     public String getRequests_recovery() {<br />
         return requests_recovery;<br />
     }

     public void setRequests_recovery(String requests_recovery) {<br />
         this.requests_recovery = requests_recovery;<br />
     }

     public int getStart_time() {<br />
         return start_time;<br />
     }

     public void setStart_time(int start_time) {<br />
         this.start_time = start_time;<br />
     }

     public String getJob_class_name() {<br />
         return job_class_name;<br />
     }

     public void setJob_class_name(String job_class_name) {<br />
         this.job_class_name = job_class_name;<br />
     }

     public String getJob_group() {<br />
         return job_group;<br />
     }

     public void setJob_group(String job_group) {<br />
         this.job_group = job_group;<br />
     }

     public String getJob_name() {<br />
         return job_name;<br />
     }

     public void setJob_name(String job_name) {<br />
         this.job_name = job_name;<br />
     }

     public String getT1() {<br />
         return t1;<br />
     }

     public void setT1(String t1) {<br />
         this.t1 = t1;<br />
     }

     public String getT2() {<br />
         return t2;<br />
     }

     public void setT2(String t2) {<br />
         this.t2 = t2;<br />
     }

     public String getT3() {<br />
         return t3;<br />
     }

     public void setT3(String t3) {<br />
         this.t3 = t3;<br />
     }

     public String getTrigger_group() {<br />
         return trigger_group;<br />
     }

     public void setTrigger_group(String trigger_group) {<br />
         this.trigger_group = trigger_group;<br />
     }

     public String getTrigger_name() {<br />
         return trigger_name;<br />
     }

     public void setTrigger_name(String trigger_name) {<br />
         this.trigger_name = trigger_name;<br />
     }

     public String getTrigger_state() {<br />
         return trigger_state;<br />
     }

     public void setTrigger_state(String trigger_state) {<br />
         this.trigger_state = trigger_state;<br />
     }

     public String getTrigger_type() {<br />
         return trigger_type;<br />
     }

     public void setTrigger_type(String trigger_type) {<br />
         this.trigger_type = trigger_type;<br />
     }<br />
 }</pre>
</div>
<p>2.Dao</p>
<div>
<pre class="prettyprint linenums"> package com.ecnt.gnop.modules.dm.quartz.dao;

 import java.sql.SQLException;<br />
 import java.util.List;

 import com.ecnt.gnop.modules.dm.quartz.bean.QuartzJobBean;

 public interface QuartzJobDao {

     public void insertQuartzJob(QuartzJobBean bean) throws SQLException;

     public void pauseQuartzJob(List&lt;QuartzJobBean&gt; list) throws SQLException;<br />
 }</pre>
</div>
<p>3.DaoImplements</p>
<div>
<pre class="prettyprint linenums"> package com.ecnt.gnop.modules.dm.quartz.dao.impl;

 import java.sql.CallableStatement;<br />
 import java.sql.Connection;<br />
 import java.sql.DriverManager;<br />
 import java.sql.SQLException;<br />
 import java.util.ArrayList;<br />
 import java.util.List;

 import oracle.sql.ARRAY;<br />
 import oracle.sql.ArrayDescriptor;<br />
 import oracle.sql.STRUCT;<br />
 import oracle.sql.StructDescriptor;

 import org.apache.commons.dbcp.DelegatingConnection;<br />
 import org.apache.log4j.Logger;

 import com.ecnt.gnop.modules.dm.quartz.bean.QuartzJobBean;<br />
 import com.ecnt.gnop.modules.dm.quartz.dao.QuartzJobDao;

 public class QuartzJobDaoImpl implements QuartzJobDao {

     private Logger log = Logger.getLogger(this.getClass().getName());

     private static Connection getConn() {<br />
         String driver = "oracle.jdbc.driver.OracleDriver";<br />
         String url = "jdbc:oracle:thin:@192.168.97.201:1521:fznop";<br />
         String username = "bi_swxt";<br />
         String password = "swxt2013";<br />
         Connection conn = null;<br />
         try {<br />
             Class.forName(driver);<br />
             // new oracle.jdbc.driver.OracleDriver();<br />
             conn = DriverManager.getConnection(url, username, password);<br />
         } catch (ClassNotFoundException e) {<br />
             e.printStackTrace();<br />
         } catch (SQLException e) {<br />
             e.printStackTrace();<br />
         }

         return conn;<br />
     }

     /**<br />
      * TOMCAT dbcp Connection --&gt; Oracle Connection<br />
      *<br />
      * @param con<br />
      * @return<br />
      * @throws SQLException<br />
      */<br />
     public static Connection getNativeConnection(Connection con) throws SQLException {<br />
         if (con instanceof DelegatingConnection) {<br />
             Connection nativeCon = ((DelegatingConnection) con).getInnermostDelegate();<br />
             return (nativeCon != null ? nativeCon : con.getMetaData().getConnection());<br />
         }<br />
         return con;<br />
     }

     public void insertQuartzJob(QuartzJobBean bean) throws SQLException {<br />
         Connection conn = null;<br />
         Connection oracleConn = null;<br />
         CallableStatement stmt = null;<br />
         String sql = "{ CALL PKG_MODULES_DM_QUARTZ.INSERT_QUARTZJOB(?) }";<br />
         try {<br />
             conn = getConn();<br />
             oracleConn = getNativeConnection(conn);<br />
             stmt = oracleConn.prepareCall(sql);<br />
             StructDescriptor structDescriptor = StructDescriptor.createDescriptor("QUARTZJOBBEAN", oracleConn);<br />
             Object[] objects = bean.toArray();<br />
             STRUCT struct = new STRUCT(structDescriptor, oracleConn, objects);<br />
             stmt.setObject(1, struct);<br />
             stmt.execute();<br />
         } catch (SQLException e) {<br />
             log.error(e.getMessage(), e);<br />
             throw e;<br />
         } finally {<br />
             if (stmt != null) {<br />
                 try {<br />
                     stmt.close();<br />
                 } catch (SQLException e) {<br />
                     e.printStackTrace();<br />
                 }<br />
             }<br />
             if (conn != null) {<br />
                 try {<br />
                     conn.close();<br />
                 } catch (SQLException e) {<br />
                     e.printStackTrace();<br />
                 }<br />
             }<br />
         }<br />
     }

     public void pauseQuartzJob(List&lt;QuartzJobBean&gt; list) throws SQLException {<br />
         Connection conn = null;<br />
         Connection oracleConn = null;<br />
         CallableStatement stmt = null;<br />
         String sql = "{ CALL PKG_MODULES_DM_QUARTZ.PAUSE_QUARTZJOB(?) }";<br />
         try {<br />
             conn = getConn();<br />
             oracleConn = getNativeConnection(conn);<br />
             stmt = oracleConn.prepareCall(sql);<br />
             StructDescriptor structDescriptor = StructDescriptor.createDescriptor("QUARTZJOBBEAN", oracleConn);<br />
             ArrayDescriptor arrayDescriptor = ArrayDescriptor.createDescriptor("QUARTZJOBARRAY", oracleConn);<br />
             ArrayList&lt;STRUCT&gt; structList = new ArrayList&lt;STRUCT&gt;();<br />
             for (QuartzJobBean bean : list) {<br />
                 STRUCT struct = new STRUCT(structDescriptor, oracleConn, bean.toArray());<br />
                 structList.add(struct);<br />
             }<br />
             ARRAY array = new ARRAY(arrayDescriptor, oracleConn, structList.toArray());<br />
             stmt.setArray(1, array);<br />
             stmt.execute();<br />
         } catch (SQLException e) {<br />
             log.error(e.getMessage(), e);<br />
             throw e;<br />
         } finally {<br />
             if (stmt != null) {<br />
                 try {<br />
                     stmt.close();<br />
                 } catch (SQLException e) {<br />
                     e.printStackTrace();<br />
                 }<br />
             }<br />
             if (conn != null) {<br />
                 try {<br />
                     conn.close();<br />
                 } catch (SQLException e) {<br />
                     e.printStackTrace();<br />
                 }<br />
             }<br />
         }<br />
     }<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyyv12q.html">TaintDroid深入剖析之启动篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/390rx6n9.html">cssRules在不同浏览器中的兼容性</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8or3yx8.html">swt小知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxgmlv9.html">Wamp 设置 www 目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/495o7yz8.html">计算空间直线与平面的交点 （C&num;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdn2gj9.html">DEDECMS数据库执行原理、CMS代码层SQL注入防御思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q74d1jq.html">菜单栏展开和收起效果&lpar;纯js&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd5r4d8.html">photoshop如何选择图层？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv35kyq.html">The7th Zhejiang Provincial Collegiate Programming Contest-&amp;gt&semi;Problem A：A - Who is Older&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjj569.html">WebGIS前端瓦片地图显示原理及实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j02mw8.html">Digital Tutors - Creating an Action Adventure Puzzle in Unity学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jn3ww8.html">SSE推送数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv2nl28.html">（基础 输入方法 栈）P1427 小鱼的数字游戏 洛谷</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m26pkpq.html">Python3练习题系列（07）&mdash;&mdash;列表操作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1y4e09.html">C&num; Task注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kk61wq.html">Java ArrayList源码剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9635lwj9.html">转：AMD规范与CMD规范的区别是什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zvg4x39.html">使用react常见的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4d5re8.html">EasyDSS RTMP流媒体服务器videojs flash播放RTMP&sol;HLS提示错误的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdj07jq.html">MyBatis介绍及使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq44640q.html">sha256 C语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4465jq.html">利用Photos 框架搭建美图秀秀相册选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r4wvd8.html">linq 的switch实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qndkg38.html">ActiveMQ初体验&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pm6xy9.html">PHP &amp;quot&semi;万能&amp;quot&semi;输出随机字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/390dxl48.html">WebForm控件Repeater</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q77y1jq.html">myBaties 和 mysql开发中遇到的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8od6d1q.html">Python爬虫学习（4）&colon; python中re模块中的向后引用以及零宽断言</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy27n29.html">Compare Version Numbers</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93j4rn8.html">js无参数对象</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
